<?PHP
	// create folder list
	function getfolderlist($mbox, $all=0) {
		$folders = array();
		if ($all != 0) {
			$folderarr = imap_list($mbox, $_SESSION["serverstring"], "*");
		} else {
			$folderarr = imap_lsub($mbox, $_SESSION["serverstring"], "*");
		}
		sort($folderarr);
		for ($i = 0; $i < count($folderarr); $i++) {
			$index = count($folders);
			$name = getmailboxname($folderarr[$i]);
			if ($i > 0) {
				if (($name[0] > $folders[$i - 1]["level"]) && ($i > 1)){
					$temp = str_replace($_SESSION["serverstring"] . $_SESSION["rootfolderpath"], "", $folderarr[$i]);
					$arr = explode($_SESSION["folderseparator"], $temp);
					if ($arr[count($arr) - 2] != $folders[$i - 1]["name"]) {
						$folders[$index]["folder"] = "";
						$folders[$index]["name"] = $arr[count($arr) - 2];
						$folders[$index]["level"] = $name[0] - 1;
						$index++;
					}
				}
			}
			$folders[$index]["folder"] = $folderarr[$i];
			$folders[$index]["name"] = $name[1];
			$folders[$index]["level"] = $name[0];
		}
		return $folders;
	}

	// takes a folder name and returns a cleaned-up version and the indenting depth
	function getmailboxname($mname)
	{
		// Strip off the server and root folder bits.
		$mname = substr($mname, strlen($_SESSION["serverstring"]));
		$mname = substr($mname, strlen($_SESSION["rootfolderpath"]));

		// if nothing is left, it's the Inbox, return that
		if ($mname == "") {
			return array(1, "Inbox");
		}

		// go through each separator until none are left, indenting each time
		$depth = 1;
		$pos = strpos($mname, $_SESSION["folderseparator"]);
		while ($pos) {
			$mname = substr($mname,$pos+1);
			$pos = strpos($mname,$_SESSION["folderseparator"]);
			$depth++;
		}

		return array($depth, $mname);
	}


	// helper function from striphtml that replaces tags appropriately
	function replacetag($tag)
	{
		$tag = trim(strtolower($tag[0]));
		if($tag == '<br>' or $tag == '<br/>' or $tag == '<br />' or $tag == '</div>' or $tag == '</p>') {
			return "\n";
		} else if ($tag == '<b>' or $tag == '</b>' or $tag == '<strong>' or $tag == '</strong>') {
			return '*';
		} else if ($tag == '<i>' or $tag == '</i>' or $tag == '<em>' or $tag == '</em>') {
			return '-';
		} else if ($tag == '&nbsp;') {
			return ' ';
		} else if ($tag == '&amp;') {
			return '&';
		} else if ($tag == '&gt;') {
			return '>';
		} else if ($tag == '&lt;') {
			return '<';
		} else {
			return "";
		}
	}


	// strips all html tags from an email
	function striphtml($str)
	{
		// strip out things between style and script tags
		$str = preg_replace("/<\s*style[^>]*>.*<\/style>/si", "", $str);
		$str = preg_replace("/<\s*script[^>]*>.*<\/script>/si", "", $str);
		$str = preg_replace("/<!--.*-->/si", "", $str);

		// clean out most tags and special entities
		return trim(preg_replace_callback("/(<\s*(?:\"[^\"]*\"|'[^']*'|[^'\">])*>|&nbsp;|&amp;|&gt;|&lt|\r\n|\n|\r;)/", "replacetag", $str));
	}


        // trims out the body of an HTML message
        function getHTMLBody($body)
        {
                // We already have a html and a body, we want to ditch any ones that are already in the email
		$body = preg_replace("/(\<html[^\>]*\>)/i","", $body);
		$body = preg_replace("/(\<\/html[^\>]*\>)/i","", $body);

		$body = preg_replace("/(\<body[^\>]*\>)/i","", $body);
		$body = preg_replace("/(\<\/body[^\>]*\>)/i","", $body);

		// Strip out the head tags
		$body = preg_replace("/<head[^>].*<\/head[^>]*>/si", "", $body);
		// strip out the script tags if we are supposed to
		if ($_SESSION["stripscripttags"] == 1) {
			$body = preg_replace("/<\s*script[^>]*>.*<\s*\/script\s[^>]*>/si", "", $body);
		}
		return $body;
        }


	// returns the text for a mailto link given a user and domain
	function makeMailLink($address)
	{
		$link = "<A HREF=\"#n\" OnClick=\"window.open('sendmail.php?toaddress=" . urlencode($address) . "', '', 'width=640,height=480,toolbars=no,scrollbars=no');\">" . $address . "</A>";
		return $link;
	}


	// alters <A> tags so that all targets point to _blank
	function fixAnchor($tag)
	{
		// is there already a target?
		if ($_SESSION["linknewwindow"] == 1) {
			if(preg_match("/ target[ ]*=[ ]*([^ >]*)/i", $tag[0]) > 0) {
				$tag = preg_replace("/ target[ ]*=[ ]*([^ >]*)/i", " target=\"_blank\"", $tag[0]);
			}
			else {
				// there is no target - let's add one
				$tag = preg_replace("/<a /i", "<a target=\"_blank\" ", $tag[0]);
			}
		} else {
			if(preg_match("/ target[ ]*=[ ]*([^ >]*)/i", $tag[0]) > 0) {
				$tag = preg_replace("/ target[ ]*=[ ]*([^ >]*)/i", "", $tag[0]);
			}
			else {
				// there is no target - let's add one
				$tag = preg_replace("/<a /i", "<a ", $tag[0]);
			}
		}
		return $tag;
	}


        // prints the main part of the message
        function printText(&$body, $type, $subtype, $encoding, $isreply, $debug=0)
        {
		if($debug) {
			echo("BODY: " . $body . "<BR><BR>");
			echo("TYPE: " . $type . "<BR><BR>");
			echo("SUBTYPE: " . $subtype . "<BR><BR>");
			echo("ENCODING: " . $encoding . "<BR><BR>");
		}
		$msgbody = "";

                if($encoding == 0) {
                        // normal text do nothing
                }
                elseif($encoding == 1) {
                        // normal text do nothing
                }
                elseif($encoding == 3) {
			// decode base64 body
                        $body = imap_base64($body);
   		}
                elseif($encoding == 4) {
			// decode quoted prinatble body
                        $body = quoted_printable_decode($body);
                }

                if($subtype == "HTML") {
                        // clean up HTML for displaying within an HTML page
			if($isreply)
	                        $msgbody = "> " . str_replace("\n", "\n> ", striphtml(getHTMLBody($body)));
			else
	                        $msgbody = getHTMLBody($body);
                }
                else {
			if($isreply)
	                        $msgbody = "> " . str_replace("\n", "\n> ", $body);
			else
	                        $msgbody = nl2br(str_replace("  ", "&nbsp; ", htmlspecialchars($body)));
                }

		// if this is reply text just return it
		// if it is HTML replace <A> tag targets with _blank
		// otherwise hyperlink web addresses and email addresses in the text
		if($isreply) {
			return $msgbody;
		}
		elseif($subtype == "HTML") {
			// replace any hyperlinks with local targets with a target _blank so they popup in nice new windows
			$msgbody = preg_replace_callback("/<a[^>]*>/i", "fixAnchor", $msgbody);

			return $msgbody;
		}
		else {
			// replace plain URL's with hyperlinked URL's
			if ($_SESSION["linknewwindow"] == 1) {
				$msgbody = preg_replace("/\b((http(s?):\/\/)|(www\.))([\w\.]+)([\/\w+\.\?=\-&\*%;]+)\b/i", "<a href=\"http$3://$4$5$6\" target=\"_blank\">$2$4$5$6</a>", $msgbody);
			} else {
				$msgbody = preg_replace("/\b((http(s?):\/\/)|(www\.))([\w\.]+)([\/\w+\.\?=\-&\*%;]+)\b/i", "<a href=\"http$3://$4$5$6\">$2$4$5$6</a>", $msgbody);
			}
			// replace email addresses with hyperlinked email addresses
			$msgbody = preg_replace("/([\d\w\.-]+)(@)([\d\w\.-]+)\b/ei", "makeMailLink(\"$0\")", $msgbody);

			return $msgbody;
		}
        }


        // decodes attachments and saves them to disk
        function decode($mbox, $part, $encoding, $name)
        {
                // open the file
                $fp = fopen($name, "w");

                if($encoding == 3) {
                        fwrite($fp, imap_base64(imap_fetchbody($mbox, $_SESSION["currentmessage"], $part, FT_UID + FT_PEEK)));
                }
                elseif($encoding == 4) {
                        fwrite($fp, imap_qprint(imap_fetchbody($mbox, $_SESSION["currentmessage"], $part, FT_UID + FT_PEEK)));
                }
                else {
                        fwrite($fp, imap_fetchbody($mbox, $_SESSION["currentmessage"], $part, FT_UID + FT_PEEK));
                }

                fclose($fp);
        }


        // cleans up a message body and prints it in a pretty way
        function printBody($mbox, $isreply=0)
        {
		$msgbody = "";

                // get the structure of the message
                $structure = @imap_fetchstructure($mbox, imap_msgno($mbox, $_SESSION["currentmessage"]));

                if(!$structure and !$isreply) {
                        $msgbody = $msgbody . "<DIV STYLE=\"font-weight: bold; text-align: center\">" . gettext("Unable to retrieve message from server") . "</DIV>\n";
                        return $msgbody;
                }

                // get the main body of the message and display it if this
                // is a basic message
                if($structure->type == 0) {
			$body = imap_fetchbody($mbox, $_SESSION["currentmessage"], 1, FT_PEEK + FT_UID);
			$msgbody = $msgbody . printText($body, $structure->type, $structure->subtype, $structure->encoding, $isreply);
		}
                elseif(($structure->type == 1) and ($structure->subtype == "ALTERNATIVE")) {
                        // set it to the basic body
                        $body = imap_fetchbody($mbox, $_SESSION["currentmessage"], 1, FT_PEEK + FT_UID);
			$type = $structure->parts[0]->type;
                        $subtype = $structure->parts[0]->subtype;
                        $encoding = $structure->parts[0]->encoding;
                        // look for html
                        for($i=0;$i<count($structure->parts);$i++) {
                                if($structure->parts[$i]->subtype == "HTML") {
                                        $body = imap_fetchbody($mbox, $_SESSION["currentmessage"], $i+1, FT_PEEK + FT_UID);
                                        $type = $structure->parts[$i]->type;
                                        $subtype = $structure->parts[$i]->subtype;
                                        $encoding = $structure->parts[$i]->encoding;
                                }
                        }
                        $msgbody = $msgbody . printText($body, $type, $subtype, $encoding, $isreply);
                }


                // leave the rest alone if it is only an alternate way to
                // display the message
                if($structure->subtype == "ALTERNATIVE")
                        return $msgbody;

                // otherwise do the same thing for each part of the message
                if(isset($structure->parts) && (count($structure->parts) > 0) and !$isreply) {
                        // add an attachments directory for this user and make sure only we can read it
			@system("rm -f users/" . $_SESSION["emailaddress"] . "/attachments/*");
			@system("mkdir -p users/" . $_SESSION["emailaddress"] . "/attachments");
			@system("chmod go-wrx users/" . $_SESSION["emailaddress"] . "/attachments");

	                $msgbody = $msgbody . "<DIV STYLE=\"text-align: center\">\n";

			for($i=0;$i<count($structure->parts);$i++) {
				if($structure->parts[$i]->type == 0) {
					$msgbody = $msgbody . "<DIV STYLE=\"text-align: left\">\n";
					$body = imap_fetchbody($mbox, $_SESSION["currentmessage"], $i+1, FT_PEEK + FT_UID);
					$msgbody = $msgbody . printText($body, $structure->parts[$i]->type, $structure->parts[$i]->subtype, $structure->parts[$i]->encoding, $isreply);
					$msgbody = $msgbody . "</DIV>\n";
				}
				elseif($structure->parts[$i]->type == 1 and $structure->parts[$i]->subtype == "ALTERNATIVE") {
					$msgbody = $msgbody . "<DIV STYLE=\"text-align: left\">\n";
					$internalstructure = $structure->parts[$i];
					// look for html
					$body = imap_fetchbody($mbox, $_SESSION["currentmessage"], (($i+1) . ".0"), FT_PEEK + FT_UID);
					$type = $internalstructure->parts[0]->type;
					$subtype = $internalstructure->parts[0]->subtype;
					$encoding = $internalstructure->parts[0]->encoding;
					for($h=0;$h<count($internalstructure->parts);$h++) {
						if($internalstructure->parts[$h]->subtype == "HTML") {
							$body = imap_fetchbody($mbox, $_SESSION["currentmessage"], (($i+1) . "." . ($h+1)), FT_PEEK + FT_UID);
							$type = $internalstructure->parts[$h]->type;
							$subtype = $internalstructure->parts[$h]->subtype;
							$encoding = $internalstructure->parts[$h]->encoding;
						}
					}
					$msgbody = $msgbody . printText($body, $type, $subtype, $encoding, $isreply);
					$msgbody = $msgbody . "</DIV>\n";
				} else {
					$printname = ucwords(strtolower($structure->parts[$i]->subtype));
					$name = "Attachment " . $i;
					$arr = $structure->parts[$i]->dparameters;
					if ($arr[0]->attribute == "filename") {
						$name = $arr[0]->value;
					}
					$arr = $structure->parts[$i]->parameters;
					for($c=0;$c<count($arr);$c++) {
						$param = $arr[$c];
						if(strtolower($param->attribute) == "name") {
							$name = $param->value;
						}
					}
					// decode and write the file to disk if it's allowed
					$filearr = explode(".", $name);
					$temp = $filearr[0];
					unset($filearr[0]);
					if (count(array_intersect($filearr, $_SESSION["extensionblacklist"])) > 0) {
						$name = $temp . "_" . implode("_", $filearr) . "." . $GLOBALS["extension_defanged"];
					}

					$name = ISDecode(addslashes($name));
					decode($mbox, $i+1, $structure->parts[$i]->encoding, ("users/" . $_SESSION["emailaddress"] . "/attachments/" . $name));
					// set up the link
					// if it's an image display it in the page
					if (($structure->parts[$i]->type == 5) && (strtolower($printname) != "tiff")){
						$msgbody = $msgbody . "<HR>\n";
						$msgbody = $msgbody . "<IMG SRC=\"users/" . $_SESSION["emailaddress"] . "/attachments/" . $name . "\"><BR>\n";
					} else {
						$msgbody = $msgbody . "<A HREF=\"users/" . $_SESSION["emailaddress"] . "/attachments/" . $name . "\">" . $name . " (" . $printname . ")</A> (" . filesize("./users/" . $_SESSION["emailaddress"] . "/attachments/" . $name) . " bytes)<BR>\n";
					}
				}
			}
		}

		if(!$isreply)
	                $msgbody = $msgbody . "</DIV>\n";

		return $msgbody;
        }

	function DeleteMessages($mbox, $messagelist) {
		imap_setflag_full($mbox,$messagelist,'\\SEEN', ST_UID);
		imap_delete($mbox, $messagelist, FT_UID);
		imap_expunge($mbox);
	}

	function SendReadConfirmation($mbox, $to, $from, $subject, $messageid, $date) {
		$envelope = array();
		if ($_SESSION["replyto"] != "") {
			$envelope["reply_to"] = $_SESSION["replyto"];
		} else {
			$envelope["reply_to"] = $_SESSION["emailaddress"];
		}
		$envelope["return_path"] = $_SESSION["emailaddress"];
		$envelope["to"] = $to;
		$envelope["subject"] = "Read: " . $subject;
		$envelope["date"] = date("r");
		$envelope["custom_headers"] = Array("X-Mailer-Version: " . $ismailversion, "X-Mailer: ISMail (http://www.insidesystems.net/projects/project.php?projectid=4)");
		$envelope["message_id"] = "<" . str_replace(" ", ".", microtime()) . "@" . $_SESSION["domain"] . ">";
		$envelope["in_reply_to"] = $messageid;
		$envelope["custom_headers"][count($envelope["custom_headers"])] = "References: " . $messageid;

		$body = array();
		$body[0] = array();
		$body[0]["type"] = TYPETEXT;
		$body[0]["subtype"] = "plain";
		$body[0]["description"] = "messagebody";
		$body[0]["contents.data"] = gettext("This is a receipt for the mail you sent to") . " <" . $from . "> " . gettext("at") . " " . $date . ".\n\n";
		$body[0]["contents.data"] .= gettext("This receipt verifies that the message has been displayed on the recipient's computer at") . " " . date("r") . ".";

		// send it
		if ($_SESSION["displayname"] == "") {
			$email = "From: \"" . addslashes($_SESSION["emailaddress"]) . "\" <" . $_SESSION["emailaddress"] . ">\n" . imap_mail_compose($envelope, $body);
		} else {
			$email = "From: \"" . addslashes($_SESSION["displayname"]) . "\" <" . $_SESSION["emailaddress"] . ">\n" . imap_mail_compose($envelope, $body);
		}
		$fp = popen($GLOBALS["mailprogram"], "w");
		fwrite($fp, $email);
		pclose($fp);

		// Stick a copy in the sent items and mark the current message as read.
		imap_setflag_full($mbox,$_SESSION["currentmessage"],'\\SEEN', ST_UID);
		$sentitems = open_mailbox($_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_SESSION["sentfoldername"]);
		imap_append($sentitems, $_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_SESSION["sentfoldername"], $email);
		$status = imap_check($sentitems);
		// We don't use UID's here so we can just mark the last one put in there as seen
		imap_setflag_full($sentitems, $status->Nmsgs,'\\SEEN');
		imap_close($sentitems);
	}
?>
